//
//  dawsonAppDelegate.m
//  dawson
//
//  Created by Neil Spring on 1/16/09.
//  Copyright University of Maryland 2009. All rights reserved.
//

#import "dawsonAppDelegate.h"
#import "CpabeTest.h"
//#include <openssl/ssl.h>

@interface dawsonAppDelegate() 
- (void) issueRequest:(NSURLRequest *)request;

@end


@implementation dawsonAppDelegate

@synthesize window;
@synthesize tabBarController;
@synthesize webview, lastRequest;


- (void)applicationDidFinishLaunching:(UIApplication *)application {
    
    // Add the tab bar controller's current view as a subview of the window
    [window addSubview:tabBarController.view];
	
	NSURLRequest *req = [NSURLRequest requestWithURL:[NSURL URLWithString:@"http://www.cs.umd.edu/~nspring/"]];
//	[webview loadRequest:req];
	[self issueRequest:req];
	[webview setDelegate:self];
	
  CpabeTestDo();	
	/* want to use - (void)loadHTMLString:(NSString *)string baseURL:(NSURL *)baseURL */
}
- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
	[webview loadData:receivedData MIMEType:@"text/html" textEncodingName:@"utf-8" baseURL:[lastRequest URL]];
	NSString *dataString = [[NSString alloc] initWithData:receivedData encoding:NSUTF8StringEncoding];
	
	
	
	//[webview loadHTMLString:@"<html><head><title>hello neil</title></head><body><a href='http://www.cs.umd.edu/'>cs.umd.edu</a></body></html>" baseURL:[lastRequest URL]];
	 [webview loadHTMLString:[dataString stringByReplacingOccurrencesOfString:@"CMSC" withString:@"ComputerScience"]  baseURL:[lastRequest URL]];
	[receivedData release];
	receivedData=nil;
}
- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
    [connection release];
	connection = nil;
    [receivedData release];
	receivedData = nil; // needed to convince that we're not trying anymore.
	// TODO: inform better.
    NSLog(@"Connection failed! Error - %@ %@",
          [error localizedDescription],
          [[error userInfo] objectForKey:NSErrorFailingURLStringKey]);
}
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    [receivedData appendData:data];
}
- (void) issueRequest:(NSURLRequest *)request {
	[self setLastRequest:request];
	NSURLConnection *theConnection=[[NSURLConnection alloc] initWithRequest:request delegate:self];
	if (theConnection) {
		receivedData=[[NSMutableData data] retain];
	} else {
		// inform the user that the download could not be made
	}	
}

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType {
	if(navigationType != UIWebViewNavigationTypeOther) {
		if(navigationType != UIWebViewNavigationTypeLinkClicked) {
			NSLog(@"asked to load %@ type %d", request, navigationType);
		} else {
			NSLog(@"asked to load %@ by click", request, navigationType);
			/* TODO: should add url to the history stack. */
		}
		[self issueRequest:request];
		return NO; /* want to say NO so that we execute the load and set the content. */
	} else {
		return YES;
	}
}


/*
// Optional UITabBarControllerDelegate method
- (void)tabBarController:(UITabBarController *)tabBarController didSelectViewController:(UIViewController *)viewController {
}
*/

/*
// Optional UITabBarControllerDelegate method
- (void)tabBarController:(UITabBarController *)tabBarController didEndCustomizingViewControllers:(NSArray *)viewControllers changed:(BOOL)changed {
}
*/


- (void)dealloc {
    [tabBarController release];
    [window release];
    [super dealloc];
}

@end

