#!/usr/bin/ruby

# http://acsc.csl.sri.com/cpabe/        

SDKversion = "2.2.1"
ENV['IPHONEOS_DEPLOYMENT_TARGET'] = SDKversion

 # for verification
Checks = { 'gettext' => [ 'lib/libgettextpo.la'],
  'libiconv' => [ 'lib/libiconv.a'],
  'gmp' => [ 'lib/libgmp.a'], 
  'pbc' => [ 'lib/libpbc.a'],
  'glib' => [ 'lib/libglib-2.0.a', 'lib/glib-2.0/include/glibconfig.h' ],
  'openssl' => [ 'lib/libcrypto.a'],
  'libbswabe' => [ 'lib/libbswabe.a' ]
}

Deps = [ 'gettext', 'libiconv', 'gmp', 'pbc', 'glib', 'openssl', 'libbswabe', 'cpabe' ]

newpath = ENV['PATH'].gsub(/\/sw[^:]*:/, "").gsub(/:\/opt\/local\/[^:]*/, "") # make sure fink isn't used. 
ENV['PATH'] = newpath
puts "Set path to %s" % ENV['PATH']

# ] # , 'libiconv', 'glib', 'gmp', 'pbc' ]

SimulatorPlace = "#{ENV['HOME']}/Developer/Platforms/iPhoneSimulator.platform/Developer/SDKs/iPhoneSimulator#{SDKversion}.sdk/"
DevicePlace = SimulatorPlace.gsub(/PhoneSimulator/, 'PhoneOS')

# Kernel.system("mkdir -p #{DevicePlace}/lib")  unless Kernel.test(?d, "#{DevicePlace}/lib")
# Kernel.system("cp /usr/local/arm-apple-darwin/heavenly/usr/lib/libcrypto.dylib #{DevicePlace}/lib") 

Kernel.system("cp /usr/local/arm-apple-darwin/heavenly/usr/lib/libgcc_s_v6.1.dylib #{DevicePlace}/lib") 
Kernel.system("ln -s #{SimulatorPlace} ~/iphonesimulator#{SDKversion}") unless test(?e, "#{ENV['HOME']}/iphonesimulator#{SDKversion}")
Kernel.system("ln -s #{DevicePlace} ~/iphoneos#{SDKversion}") unless test(?e, "#{ENV['HOME']}/iphoneos#{SDKversion}")

{'simulator' => SimulatorPlace, 'device' => DevicePlace }.each do |target, place|
  Deps.each { |base|
    Dir.glob("dependencies/#{base}*.tar.*").each { |distfile|
      # skip if already did it.
      unless Checks.has_key?(base) and !Checks[base].detect { |checkfile| !Kernel::test(?e, place + checkfile) } then
        puts "processing tarfile: %s" % distfile
        tarfile = File.basename(distfile)
        unless Dir.glob("dependencies/#{base}-*/*").empty? then
          puts "clearing out the directory from a prior build..." 
          Kernel.system("rm -rf dependencies/#{base}-*/*");
          puts "...done"
        end
        Kernel.system("cd dependencies && tar xf#{ distfile =~ /bz2$/ ? 'j' : 'z'} #{tarfile}") or fail "failed to untar #{base}"
        Dir.glob("dependencies/#{base}-*.patch").each { |patch|
          puts "applying patch: %s" % patch
          command = "cd dependencies/#{base}*/ && patch -p1 < ../../#{patch}"
          Kernel.system("cd dependencies/#{base}*/ && patch -p1 < ../../#{patch}") or fail "failed to apply patch #{base}"
        }
        Kernel.system("cd dependencies/#{base}*/ && ../../build_for_iphoneos #{target}") or fail "failed to build #{base}"
        puts "done processing tarfile: %s" % distfile
        if Checks.has_key?(base) then
          puts "checking for signature file: %s" % Checks[base]
          Checks[base].each { |signature_file|
            unless Kernel::test(?e, place + signature_file) then
              puts "fail: %s%s not installed." % [place,  signature_file ]
              exit
            end
          }
          puts "seems okay."
        else 
          puts "not sure what to look for after building #{base}."
        end
      end
    }
  }

  if Kernel.test(?e, "dependencies/cpabe-0.7/libpolicy_lang.a") then
    Kernel.test(?d, "#{place}/include/cpabe") || Kernel.system("mkdir -p #{place}/include/cpabe")
    Kernel.system("cp dependencies/cpabe-0.7/common.h #{place}/include/cpabe")
    Kernel.system("cp dependencies/cpabe-0.7/policy_lang.h #{place}/include/cpabe")
    Kernel.system("ranlib dependencies/cpabe-0.7/libpolicy_lang.a")
    Kernel.system("cp dependencies/cpabe-0.7/libpolicy_lang.* #{place}/lib")
    
#    if target == 'simulator' then
#       Kernel.system("cp /usr/lib/libcrypto.dylib #{place}/lib") 
#    else
#       Kernel.system("cp /usr/local/arm-apple-darwin/heavenly/usr/lib/libcrypto.dylib #{place}/lib") 
#    end
    
  else 
    puts "cpabe fail."
  end
end
